%define ver_progsreiserfs 0.3.1-rc8
%global oversion 7.2

Name:		testdisk
Version:	7.2.0
Release:	%mkrel 1
License:	GPLv2+
Summary:	Tool to check and undelete partition
Summary(pl):	Narzędzie do sprawdzania i przywracania partycji
Summary(fr):	Outil pour vérifier et restaurer la partition
Group:		System/Kernel and hardware
Source0:	http://www.cgsecurity.org/%{name}-%{oversion}.tar.xz
URL:		http://www.cgsecurity.org/wiki/TestDisk
Source1:	progsreiserfs-%{ver_progsreiserfs}.tar.bz2
Source2:	qi-testdisk.desktop
Source3:	testdisk-start
Source4:	testdisk.png
Source5:	qi-photorec.desktop
Source6:	photorec-start
Source7:	photorec.png
Source8:	qphotorec.desktop
Source9:	testdisk.pdf
BuildRoot:	%{_tmppath}/%{name}-%{oversion}-buildroot

BuildRequires:	pkgconfig(ncursesw)
BuildRequires:	pkgconfig(ext2fs)
BuildRequires:	pkgconfig(libntfs-3g)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(zlib)
BuildRequires:	pkgconfig(libewf)
BuildRequires:	pkgconfig(uuid)
BuildRequires:	gettext-devel

BuildRequires:	desktop-file-utils
BuildRequires:	pkgconfig(uuid)

BuildRequires: qtbase5-devel
BuildRequires: qttools5

Obsoletes: testdisk <= 7.2WIP-12
Conflicts: testdisk <= 7.2WIP-12
  
%package -n photorec
Summary:	Data recovery software
Group:		System/Kernel and hardware
Requires: testdisk = %{version}
Conflicts: photorec <= 7.2WIP-12

%description
http://www.cgsecurity.org/wiki/TestDisk
TestDisk can:
* Fix partition table, recover deleted partition
* Recover FAT32 boot sector from its backup
* Rebuild FAT12/FAT16/FAT32 boot sector
* Fix FAT tables
* Rebuild NTFS boot sector
* Recover NTFS boot sector from its backup
* Fix MFT using MFT mirror
* Locate ext2/ext3/ext4 Backup SuperBlock
* Undelete files from FAT, exFAT, NTFS and ext2 filesystem
* Copy files from deleted FAT, exFAT, NTFS and ext2/ext3/ext4 partitions.

TestDisk has features for both novices and experts. For those who know little or nothing about data recovery techniques, TestDisk can be used to collect detailed information about a non-booting drive which can then be sent to a tech for further analysis. Those more familiar with such procedures should find TestDisk a handy tool in performing onsite recovery. 
Tool to check and undelete partition.
Works with the following filesystems:
    * BeFS ( BeOS )
    * BSD disklabel ( FreeBSD/OpenBSD/NetBSD )
    * CramFS, Compressed File System
    * DOS/Windows FAT12, FAT16 and FAT32
    * HFS and HFS+, Hierarchical File System
    * JFS, IBM's Journaled File System
    * Linux Ext2 and Ext3
    * Linux Raid
          o RAID 1: mirroring
          o RAID 4: striped array with parity device
          o RAID 5: striped array with distributed parity information
          o RAID 6: striped array with distributed dual redundancy information 
    * Linux Swap (versions 1 and 2)
    * LVM and LVM2, Linux Logical Volume Manager
    * Mac partition map
    * Novell Storage Services NSS
    * NTFS ( Windows NT/2K/XP/2003/Vista )
    * ReiserFS 3.5, 3.6 and 4
    * Sun Solaris i386 disklabel
    * Unix File System UFS and UFS2 (Sun/BSD/...)
    * XFS, SGI's Journaled File System 

%description -l pl
http://www.cgsecurity.org/wiki/TestDisk
Działa z następującymi systemami plików:
     * BeFS (BeOS)
     * Etykieta dysku BSD (FreeBSD/OpenBSD/NetBSD)
     * CramFS, skompresowany system plików
     * DOS/Windows FAT12, FAT16 i FAT32
     * HFS i HFS+, hierarchiczny system plików
     * JFS, kronikowany system plików IBM
     * Linux Ext2 i Ext3
     * Napad na Linuksa
           o RAID 1: kopiowanie lustrzane
           o RAID 4: tablica rozłożona z urządzeniem parzystości
           o RAID 5: tablica rozłożona z rozproszoną informacją o parzystości
           o RAID 6: macierz rozłożona z rozproszonymi informacjami o podwójnej redundancji
     * Zamiana Linuksa (wersje 1 i 2)
     * LVM i LVM2, menedżer woluminów logicznych systemu Linux
     * Mapa partycji Mac
     * Usługi przechowywania danych NSS firmy Novell
     * NTFS (Windows NT/2K/XP/2003/Vista)
     * ReiserFS 3.5, 3.6 i 4
     * Etykieta dysku Sun Solaris i386
     * System plików Unix UFS i UFS2 (Sun/BSD/...)
     * XFS, kronikowany system plików SGI

%description -l fr
http://www.cgsecurity.org/wiki/TestDisk
Outil pour vérifier et restaurer des partitions.
Fonctionne avec les systèmes de fichiers suivants :
     *BeFS (BeOS)
     * Étiquette de disque BSD ( FreeBSD/OpenBSD/NetBSD )
     * CramFS, système de fichiers compressés
     * DOS/Windows FAT12, FAT16 et FAT32
     * HFS et HFS+, système de fichiers hiérarchique
     * JFS, le système de fichiers journalisé d'IBM
     * Linux Ext2 et Ext3
     * Raid Linux
           o RAID 1 : mise en miroir
           o RAID 4 : matrice répartie avec périphérique de parité
           o RAID 5 : matrice répartie avec informations de parité distribuées
           o RAID 6 : matrice répartie avec informations de double redondance distribuée
     * Linux Swap (versions 1 et 2)
     * LVM et LVM2, gestionnaire de volumes logiques Linux
     * Carte de partition Mac
     * Services de stockage Novell NSS
     * NTFS (Windows NT/2K/XP/2003/Vista)
     *ReiserFS 3.5, 3.6 et 4
     * Étiquette de disque Sun Solaris i386
     * Système de fichiers Unix UFS et UFS2 (Sun/BSD/...)
     * XFS, le système de fichiers journalisés de SGI

%description -n photorec
http://www.cgsecurity.org/wiki/PhotoRec
PhotoRec is file data recovery software designed to recover lost files
including video, documents and archives from Hard Disks and CDRom and lost
pictures (thus, its 'Photo Recovery' name) from digital camera memory.

PhotoRec ignores the filesystem and goes after the underlying data, so it
will still work even if your media's filesystem has been severely damaged
or re-formatted.

%package -n qphotorec
Summary: GUI for PhotoRec, a data recovery software
Group: File tools
Requires: testdisk = %{version}
Requires: photorec = %{version}
Conflicts: qphotorec <= 7.2WIP-12

%description -n qphotorec
QPhotoRec is file data recovery GUI software designed to recover lost files
including video, documents and archives from Hard Disks and CDRom and lost
pictures (thus, its 'Photo Recovery' name) from digital camera memory.

See online documentation at:
http://www.cgsecurity.org/wiki/PhotoRec

%package -n testdisk-photorec-xfcedesk
Summary: testdisk+photorec integration for xfce-de
Group:	File tools
Requires: testdisk = %{version}
Requires: photorec = %{version}
Requires: xfce4-terminal
Conflicts: testdisk-photorec-xfcedesk <= 7.2WIP-12

%description -n testdisk-photorec-xfcedesk
Better integration for xfce-de with
startup testdisk or photorec on a xfce-terminal
from your desktop

%prep
%setup -qn %{name}-%{oversion}

%autopatch -p1

%build
./configure --prefix=/usr
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=%buildroot install

pushd src
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
install -m 0755 testdisk $RPM_BUILD_ROOT%{_sbindir}/testdisk
install -m 0755 photorec $RPM_BUILD_ROOT%{_sbindir}/photorec
install -m 0755 fidentify $RPM_BUILD_ROOT%{_sbindir}/fidentify

popd

# install xfce4-terminal as startup
install -m 0755 %SOURCE3 $RPM_BUILD_ROOT%{_bindir}/testdisk-start
install -m 0755 %SOURCE6 $RPM_BUILD_ROOT%{_bindir}/photorec-start

rm -fr $RPM_BUILD_ROOT%{_bindir}/testdisk
rm -fr $RPM_BUILD_ROOT%{_bindir}/photorec
rm -fr $RPM_BUILD_ROOT%{_bindir}/fidentify


# install desktopfiles
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
install -m 0644 %SOURCE2 %buildroot%{_datadir}/applications/qi-testdisk.desktop
install -m 0644 %SOURCE5 %buildroot%{_datadir}/applications/qi-photorec.desktop
# install icons
# mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons
install -m 0644 %SOURCE4 %buildroot%{_datadir}/icons/testdisk.png
install -m 0644 %SOURCE7 %buildroot%{_datadir}/icons/photorec.png

rm -f %{buildroot}%{_datadir}/applications/qphotorec.desktop

# change to use gksu by launch it as default required
install -m 0644 %SOURCE8 %buildroot%{_datadir}/applications/qphotorec.desktop

# install the pdf
install -m 0644 %SOURCE9 %buildroot%{_datadir}/doc/testdisk/testdisk.pdf

%clean
rm -rf $RPM_BUILD_ROOT

%post -n qphotorec
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
%update_menus

%postun -n qphotorec
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
%clean_menus


%files
%{_datadir}/doc
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/testdisk
%{_mandir}/man8/testdisk.8*
%{_mandir}/zh_CN/man8/testdisk.8*

%files -n photorec
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/photorec
%attr(755,root,root) %{_sbindir}/fidentify
%{_datadir}/icons/photorec.png
%{_mandir}/man8/photorec.8*
%{_mandir}/man8/fidentify.8*
%{_mandir}/zh_CN/man8/photorec.8*
%{_mandir}/zh_CN/man8/fidentify.8*

%files -n qphotorec
%{_bindir}/qphotorec
%{_datadir}/applications/qphotorec.desktop
%{_iconsdir}/hicolor/48x48/apps/qphotorec.png
%{_iconsdir}/hicolor/scalable/apps/qphotorec.svg
%{_mandir}/man8/qphotorec*
%{_mandir}/zh_CN/man8/qphotorec*

%files -n testdisk-photorec-xfcedesk
%attr(755,root,root) %{_bindir}/photorec-start
%{_datadir}/applications/qi-photorec.desktop
%attr(755,root,root) %{_bindir}/testdisk-start
%{_datadir}/icons/testdisk.png
%{_datadir}/applications/qi-testdisk.desktop
%{_datadir}/icons/photorec.png


%changelog
* Mon Mar 04 2024 onkelho <oh.quait at gmail.com> - 7.2.0-1quait2024
- released now - 10 day ago
